Program Try;

{*

 How  to trap errors from your programs explained by MugSHot, released as PD
 for Pc-Express Magzine Issue #6.

 The idea is quite simple. Instead of trying to trap all kinds of errors, we
 can let TP to do the job for us. Whenever TP stops execution of the program
 (because of a run time error or just because the program stops in a natural
 way) it executes the default procedure of exit : ExitProc.   Then TP checks
 the status of two variables from  the SYSTEM unit : ErrorAddr and ExitCode.
 If  there was a run   time  error  then   ErrorAddr is not NIL and ExitCode
 containes the run time  error code. Otherwise ExitCode containes the error-
 level  that  will be  set  for  DOS and  ErrorAddr  is  NIL.

 Fortunatly  we can easily  redefine the ExitProc, and  thus to overtake the
 control from  TP. The problem  is that  we got to be able to get back or to
 jump  to  any point  of  the program  ( even to  jump inside  a procedure /
 function). And  that is where the jump unit comes in handy, the routines of
 the jump unit came from turbo professional.

 The trapping works fine under Windows/Dos. To run it with WINDOWS recompile
 the JUMP unit for Windows target. Then add WinCrt to the Uses statement and
 remove Mark/Release lines ( because there is no Mark/Release for Windows ).

 I have put some english comments in this source and the error message is in
 DUTCH but that shouldn't stop you. I also added a nice  (atleast i think it
 is) small screen with movin crap. Perhaps you can learn a  little something
 from that as well... that's it for me so have fun  with these cool sources!

*}
{- begin jump unit --------------------------------------------------------
{
Unit Jump;
Interface
Type JumpRecord = Record
                        SpReg,
                        BpReg  : Word;
                        JmpPt  : Pointer;
                  end;

Procedure SetJump ( Var JumpDest : JumpRecord );
Storing SP,BP and the address

inline(
       $5F/
       $07/
       $26/$89/$25/
       $26/$89/$6D/$02/
       $E8/$00/$00/

       $58/
       $05/$0C/$00/
       $26/$89/$45/$04/
       $26/$8C/$4D/$06);


Procedure LongJump ( Var JumpDest : JumpRecord );
{Restore everything and jump
inline(
       $5F/
       $07/
       $26/$8B/$25/
       $26/$8B/$6D/$02/
       $26/$FF/$6D/$04);

Implementation
End.
-------------- end of jump unit ------------------------------------------- }

uses winttt5, {for saving the screen}
     pktimer, {calibrate delay}
     jump,    {jumping}
     crt;

var str    : array [1..3] of string[80];
    temp   : string;
    i,loop,
    x,y    : byte;
    OldExit : Pointer;
    MyAddr  : JumpRecord;
    MyHeap  : Pointer;

procedure pasteinstring(start : byte; instring : string; var outstr : string);
var counter : byte;
begin
 for counter:=1 to length(instring) do
 outstr[start+counter-1]:=instring[counter];
end;

procedure MyExit;

var ch : char;

Procedure explainerror(code : byte);
var class : string[16];
    msg   : string;

begin
      case code of
         1.. 99: Class := 'DOS ERROR';
       100..149: Class := 'I/O ERROR';
       150..199: Class := 'CRITICAL ERROR';
       200..249: Class := 'FATAL ERROR';
       else      Class := 'UNKNOWN ERROR';
      end;

      case code of
         2: Msg := 'File not found';
         3: Msg := 'Path not found';
         4: Msg := 'Too many open files';
         5: Msg := 'File access denied';
         6: Msg := 'Bad file handle';
        12: Msg := 'Bad file access code';
        15: Msg := 'Bad drive number';
        16: Msg := 'Can''t remove current dir';
        17: Msg := 'Can''t rename across drives';

       100: Msg := 'Disk read error, read past eof on Typed File';
       101: Msg := 'Disk write error';
       102: Msg := 'File not assigned';
       103: Msg := 'File not open';
       104: Msg := 'File not open for input';
       105: Msg := 'File not open for output';
       106: Msg := 'Bad numeric format';

       150: Msg := 'Disk is write-protected';
       151: Msg := 'Unknown diskette unit';
       152: Msg := 'Drive not ready';
       153: Msg := 'Unknown command';
       154: Msg := 'CRC error in data';
       155: Msg := 'Bad drive request structure length';
       156: Msg := 'Disk seek error';
       157: Msg := 'Unknown diskette type';
       158: Msg := 'Sector not found';
       159: Msg := 'Printer out of paper';
       160: Msg := 'Device write fault';
       161: Msg := 'Device read fault';
       162: Msg := 'Hardware failure';

       200: Msg := 'Division by zero';
       201: Msg := 'Range check';
       202: Msg := 'Stack overflow';
       203: Msg := 'Heap overflow'+' (Not enough memory to run)';
       204: Msg := 'Bad pointer operation';
       205: Msg := 'Floating point overflow';
       206: Msg := 'Floating point underflow';
       207: Msg := 'Bad floating point operation';
       else Msg := 'Unkown.';
      end;

Writeln('  '+class+': '+msg);
end;

label tryagain;
begin
ExitProc:=OldExit;   {this is so goddamn important....}
if ErrorAddr <> nil then
begin
savescreen(9);
clrscr;
for i:=1 to 3 do str[i]:='';
Textcolor(3);
write('Ŀ');
write('                                                                              ');
write('                                                                              ');
write('                                                                              ');
write('');

writeln;
TextColor(7);
writeln(' Er is een fout in het programma opgetreden omdat U iets gedaan heeft wat wij');
writeln(' niet verwacht hadden. U kunt nu kiezen om te stoppen of het programma te her-');
writeln(' vatten voordat de fout optrad.');
writeln;
writeln(' Hieronder  staan gegevens  voor de programmeur  van het programma,  mocht de');
writeln(' fout vaker voorkomen neemt U dan kontakt met ons op en vermeld de informatie');
writeln(' die hier beneden staat. Onze excuses voor het ongemak.');
writeln;
writeln(' [Fout informatie]');
ExplainError(ExitCode);
writeln(' ');
writeln;
ExitCode  := 0;
ErrorAddr := nil;

write(' S)toppen of H)ervatten: '); x:=wherex; y:=wherey;

 randomize;
 for i:=1 to 3 do for loop := 1 to 78 do str[i]:=str[i]+(chr(random(222)+33));

 temp:='MugSHot was here'; {my personal touch...}
 pasteinstring(78-length(temp),temp,str[1]);

 for i:=1 to 3 do gotoxy(2,1+i); write(str[i]);

tryagain:
repeat
 calibratedelay;
 for i:=1 to 3 do
 begin
  if i in [1,3] then delete(str[i],1,1)
  else delete(str[i],78,1);

  if i in [1,3] then str[i]:=str[i]+chr(random(222)+33)
  else str[i]:=chr(random(222)+33)+str[i];

  gotoxy(2,1+i);
  write(str[i]);
  gotoxy(x,y);
 end;
until keypressed;
ch:=readkey;
 case upcase(ch) of
  'H' : begin restorescreen(9); LongJump(MyAddr); end;
  #27,
  'S' : begin clrscr; writeln('U heeft gekozen om te stoppen.'); halt; end;
 else goto tryagain;
 end;
end;
end;

begin
 OldExit:=ExitProc;     {save turbo pascals exit procedure}
 Mark(MyHeap);          {save heap}

 SetJump(MyAddr);       {set the jump address}
 ExitProc:=@MyExit;     {add MyExit to the the exitprocedure}
 Release(MyHeap);       {restore heap}

 clrscr;
 writeln('Press a key to crash...');
 readkey;
 writeln(i/0); {creates the divide by zero error}
end.